<?php
//inclusion des fichiers principaux
$path = $_SERVER['DOCUMENT_ROOT'];
include_once $path.'/common.php';
include_once $path.'/Model_esia.php';
include_once $path.'/Model_adm.php';
include_once $path.'/plugin/gesa/gesa_model.php';

$arr = Model_esia::getWebPlugin($dbconnection,false,'WEBP_IMPORT');
$plugin_url = $arr[0]['apache_path'];

$page_url = "$plugin_url"."host-list.php?task_id=".$_REQUEST['task_id'];
$template_path= $path.$plugin_url.'template/';
//$smarty->assign('title',$arr[0]['name']);

include_once $path.$plugin_url.'/inc/Model_import-module.php';

//NAVBAR
$navbar->addElement($lang[$arr[0]['name']],"$plugin_url/".$arr[0]['index_page'],$arr[0]['icon']);
$navbar->addElement("Scan ".$_REQUEST['task_id'],$page_url,"$plugin_url/nodes.png");

if($user->getDroits($dbconnection,"esia_import") == 1
		&& $user->getDroits($dbconnection,"esia_administration") == 1
		&& $user->getDroits($dbconnection,"esia_device") == 1 ){

	define('PLUGIN_INTERVAL',300000);

	define('ICMP_PLUGIN_NAME','CHECK_ICMP');
	define('ICMP_GESA_NAME','GESA_ICMP');
	define('ICMP_ONLY','Plugin ICMP');

	define('PHONE_PLUGIN_NAME','CHECK_ICMP_GIGUE_MAC');
	define('PHONE_GESA_NAME','GESA_ICMP_GIGUE_MAC');
	define('PHONE_ONLY','Plugin ICMP_MAC');

	$error_messages = array();
	$output_array=array();

	if(isset($_REQUEST['action']) && $_REQUEST['action'] == 'save'){
		$snmp_version =array("no"=>null,"v1"=>1,"v2c"=>2);

		$data = json_decode($_REQUEST["data"],true);

		//Parsing des données
		$nodes = array();
		foreach($data as $key => $table_row){
			$node = array();

			foreach($table_row as $field){
				if(strstr($field["name"],'rdp')!== false){
					$node['rdp'][] = $field["value"];
				}
				elseif ( $field["name"] == "group")
				{
					$node[$field["name"]][] = $field["value"];
				}
				else
				{
					$node[$field["name"]] = $field["value"];
				}
			}
			if(count($node)>0) { //On ignore la ligne vide de la checkbox all dans le header
				$nodes[$key] = $node;
			}
		}
		//Creation d'un device
		foreach($nodes as $node){

			$node_ident_infos = $node["name"] .' ('.$node["address"].')';
			$warnings =array();

			//Ajout du device
			$node_added = false;
			if(empty($node["name"])){
				$error_message = sprintf($lang['IMPORT_HOSTS_UNABLE_TO_ADD_NODE_ERROR'],$node_ident_infos,$lang['IMPORT_NODENAME_EMPTY']);
			}
			else{
				try{
					$device = new Device();
					$device->setName($node["name"]);
					$device->setType($node["type"]);
					$device->setIPv4Adress($node["address"]);

					if($snmp_version[$node["snmp_ver"]]!=null) {
						$device->setSNMPVersion($snmp_version[$node["snmp_ver"]]);
						$device->setSNMPCommunity($node["community"]);
					}

					$group_ids = getGroupIdArrayByArrayPath($dbconnection,$node["group"]);
					$n_wanted_groups = count($node["group"]);
					$n_groups_founds = count($group_ids);

					if($n_wanted_groups != $n_groups_founds ) $warnings[] = sprintf($lang['IMPORT_HOSTS_GROUP_ADD_NUMBER_ERROR'],$n_groups_founds,$n_wanted_groups);

					$device->setGroupList($group_ids);

					$device->setId(Model_adm::addNode($dbconnection,$device));
					// AJOUT
					if(isset($node["rdp"][0]) && !empty($node["rdp"][1]))
					{
						$param['type']	= $node["rdp"][0];
						$param['id']	= $node["rdp"][1];
						Model_adm::addAdvanceNodeConfig($dbconnection,$device->getId(),Model_adm::getAdvanceNodeConfigType($dbconnection,'RDP')[0]['id'],$param);
					}
					Model_adm::addAddDeviceInRootGroup($dbconnection,$device);

					if( isset($_REQUEST['gesa']) && !empty($_REQUEST['gesa']) ){
						$gesa=Model_gesa::getGesaIDBySN($dbconnection,$_REQUEST['gesa']);
						Model_adm::linkGesaNode($dbconnection,$gesa,$device->getId());
					}

					$node_added = true;
				}
				catch(Exception $ex){
					if(preg_match("/device_name_unique/",$ex->getMessage()))
					{
						$error_message = sprintf($lang['IMPORT_HOSTS_DUPLICATE_NAME'],$node_ident_infos);
					}
					else
					{
						$error_message = sprintf($lang['IMPORT_HOSTS_UNABLE_TO_ADD_NODE_ERROR'],$node_ident_infos,$ex->getMessage());
					}
				}
			}

			if($node_added){
				//Ajout des pattern et/ou plugins
				$wanted_patterns = trim($node["pattern"]);
				if(!empty($wanted_patterns) ){
					$model_patterns = null;
					try{
						$model_patterns = Model_adm::getPatternService($dbconnection);
					}
					catch(Exception $ex){
						$warnings[] = sprintf($lang['IMPORT_HOSTS_GET_PATTERN_LIST_ERROR'],$ex->getMessage());
					}

					if($model_patterns  != null){
						$snmp_advised = true;
						foreach(explode(",",$wanted_patterns) as $wanted_pattern){ //On parcours la liste de patterns a ajouter
							$wanted_pattern = trim($wanted_pattern);
							if(empty($wanted_pattern)) continue;

							if( $wanted_pattern == ICMP_ONLY || $wanted_pattern == PHONE_ONLY){ //Ajout de plugin icmp
								$snmp_advised= false;
								if( $wanted_pattern == ICMP_ONLY ){
									$gesa_plugin = ICMP_GESA_NAME;
									$check_plugin = ICMP_PLUGIN_NAME;
								}
								else{
									$gesa_plugin = PHONE_GESA_NAME;
									$check_plugin = PHONE_PLUGIN_NAME;
								}

								if( isset($_REQUEST['gesa']) && $_REQUEST['gesa']){
									$plugin_name = $gesa_plugin;
								}
								else{
									$plugin_name = $check_plugin;
								}
								try{
									$srv_fields = array_shift(Model_esia::getPlugin($dbconnection,$plugin_name));
									$parameters = $srv_fields['parameter'];
									if($wanted_pattern == PHONE_ONLY){

										$addr = $node["address"];
										$mask = '255.255.255.0';

										$int_addr = ip2long($addr);
										$int_mask = ip2long($mask);
										$int_net = $int_addr & $int_mask;

										if( $int_net == 0 || $int_bc >= 3758096384){
											$warnings[]=sprintf($lang['IMPORT_HOSTS_ADD_PLUGIN_ERROR'],ICMP_PLUGIN_NAME,'');
										}
										else{
											$range_net = long2ip($int_net) . '/24';

											if($plugin_name == PHONE_GESA_NAME){
												if(preg_match('/(.* -a) \"\S+\s(\S+)\s(\S+)/',$srv_fields['parameter'],$matches)){
													$parameters = $matches[1] .' "'.$node['mac'].' '.$matches[2].' '.$matches[3].' '.$range_net.'"';
												}
											}
											else{
												if(!preg_match('/-w\s+(\d+,\d+)/',$srv_fields['parameter'],$pWarn)){
													$pWarn[1] = '50,50';
												}
												if(!preg_match('/-c\s+(\d+,\d+)/',$srv_fields['parameter'],$pCrit)){
													$pCrit[1] = '100,100';
												}
												$parameters = '-M '.$node['mac'].' -w '.$pWarn[1].' -c '.$pCrit[1].' -R '.$range_net;
											}
										}
									}
									Model_adm::addService(
											$dbconnection,
											$srv_fields['name'],
											$srv_fields['id'],
											$device->getId(),
											$srv_fields['interval_time'],
											$parameters,
											$srv_fields['priority'],
											null,null,null,null,null
											);
								}
								catch(Exception $ex){
									$warnings[]=sprintf($lang['IMPORT_HOSTS_ADD_PLUGIN_ERROR'],ICMP_PLUGIN_NAME,$ex->getMessage());
								}
							}
							else{//Ajout de pattern
								//On recherche pattern à ajouter.
								$pattern_fields = null;
								foreach($model_patterns as $model_pattern){
									if($model_pattern['name'] == $wanted_pattern){
										$pattern_fields = $model_pattern;
										break;
									}
								}

								//On ajoute le pattern
								if($pattern_fields == null)	$warnings[]=sprintf($lang['IMPORT_HOSTS_FOUND_PATTERN_ERROR'],$wanted_pattern);
								else
								{
									try{
										Model_adm::assignPatternServiceNode($dbconnection,$pattern_fields["id"],$device->getId());
									}
									catch(Exception $ex){
										$warnings[] = $warnings[]=sprintf($lang['IMPORT_HOSTS_ADD_PATTERN_ERROR'],$wanted_pattern,$ex->getMessage());
									}
								}
							}
						}
					}
				}
				else $warnings[] = $lang['IMPORT_HOSTS_NO_PATTERN_SELECTED_ERROR'];
			}

			if($snmp_advised && $snmp_version[$node["snmp_ver"]]==null) {
				$warnings[] = $lang['IMPORT_NO_SNMP_CONFIGURED'];
			}

			if(!$node_added) send_status('alert',$error_message);
			else if(count($warnings) == 0) send_status('success',sprintf($lang['IMPORT_HOSTS_NODE_ADDED_MESSAGE'],$node_ident_infos));
			else{
				send_status('warning',sprintf($lang['IMPORT_HOSTS_NODE_ADDED_WARNINGS'],$node_ident_infos)."</br>".implode("</br>",$warnings));
			}
		}
	}
	else {
		if(!isset($_REQUEST['task_id']))
			$error_messages[]=$lang['IMPORT_HOSTS_NO_TASK_ID_GIVEN_ERROR'];
			else{
				$array_groups = getAllGroups($dbconnection);
				$array_type	= getAllTypes($dbconnection);
				$array_pattern = getAllPatterns($dbconnection);
				array_unshift($array_pattern,ICMP_ONLY);

				$taskid=$_REQUEST['task_id'];
				$smarty->assign('taskid',$taskid);

				$db_data = Model_ScanModule::getScanningTask($dbconnection,$taskid);
				if($db_data != null){
					$full_path = $db_data['data_path'];

					$raw = file_get_contents($full_path);
					$parsed = json_decode($raw,true);

					if(!isset($parsed["status"])){
						$error_messages[] = sprintf($lang['IMPORT_ALL_PARSING_FILE_ERROR'],$taskid,$full_path);
					}
				}
				else
					$error_messages[] = sprintf($lang['IMPORT_HOSTS_FOUND_TASK_ERROR'],$taskid);
			}

			if(isset($parsed["status"])){
				if( empty($parsed['hosts']) || count($parsed['hosts']) == 0){
					$error_messages[]= $lang['IMPORT_HOSTS_NO_DETECTED_HOSTS_ERROR'];
				}
				else{
					$header_array = array(
							'logo_type'	=> array('priority'=>3,'type'=>'img'),
							'http_url'	=> array('priority'=>2,'type'=>'read-only'),
							'rdp'	=> array('priority'=>3,'type'=>'choose','values'=>array('none','teamviewer','logmein'),'propageconfig'=>true),
							'name'		=> array('priority'=>"critical",'type'=>'encode','propageconfig'=>false),
							'same_addr'	=> array('priority'=>2,'type'=>'read-only'),
							'mac'		=> array('priority'=>4,'type'=>'read-only'),
							'address' 	=> array('priority'=>2,'type'=>'read-only'),
							'hostname'	=> array('priority'=>4,'type'=>'read-only'),
							'group'		=> array('priority'=>"critical",'type'=>'choose','values'=>$array_groups,'propageconfig'=>true, 'multiple'=>true, 'placeholder'=>$lang['ADM_NODE_GROUP_SELECT_TIPS']),
							'snmp_status' => array('priority'=>4,'type'=>'read-only'),
							'snmp_ver'	=> array('priority'=>1,'type'=>'choose','values'=>array('no','v1','v2c'),'propageconfig'=>true),
							'community' => array('priority'=>1,'type'=>'encode','propageconfig'=>true),
							'type'		=> array('priority'=>1,'type'=>'choose','values'=>$array_type,'propageconfig'=>true),
							'pattern'         => array('priority'=>"critical",'type'=>'choose','values'=>$array_pattern,'propageconfig'=>true, 'multiple'=>true, 'placeholder'=>$lang['ADM_NODE_PATTERN_SELECT_TIPS']),
					);

					$already_encoded_list = getAlreadyEncodedNodes($dbconnection,null);

					foreach($parsed['hosts'] as $host){
						if( $parsed['type'] == 'MAC-ICMP' ){
							$name = $host['mac'];
						}
						else{
							$name = $host['address'];
						}
						if(!empty($host['hostname']))
                        {
                        	$name = $host['hostname'];
                        }
                        elseif(preg_match("/STRING:\s\"(.*)\"/",$host['snmp']['details']['sysName'],$match))
                        {
                        	if(preg_match("/[a-zA-Z0-9]/",$match[1]))
                            {
                            	$name = $match[1];
                            }
                        }

						$ports_list=array();
						if(isset($host['ports'])){
							foreach($host['ports'] as $port){
								$ports_list[$port['portid']] = $port['status'];
							}
						}

						if( isset($ports_list[443]) && $ports_list[443] == 'open' ) $http_port = 443;
						else if( isset($ports_list[80]) && $ports_list[80] == 'open' ) $http_port = 80;
						else if( isset($ports_list[8080]) && $ports_list[8080] == 'open' ) $http_port = 8080;
						else $http_port = null;

						$http_url=null;

						if( $http_port == 443 ) $http_url = 'https://'.$host['address'].":$http_port";
						else if ( $http_port != null ) $http_url = 'http://'.$host['address'].":$http_port";

						$snmp_status = 'unknown';
						if( isset($ports_list[161]) ) $snmp_status=str_replace("|","_",$ports_list[161]);

						$snmp = 'no';
						if(isset($host['snmp']['version'])){
							switch($host['snmp']['version']){
								case 1 : $snmp = 'v1';	break;
								case 2 : $snmp = 'v2c';	break;
								default: $snmp = 'no'; 	break;
							}
						}

						$logo_type['text'] = $lang['IMPORT_HOST_TYPE_NO_DETECTED'];
						unset($logo_type['img']);
						$dev_type = 'none';
						$pattern = ICMP_ONLY;
						if($snmp != 'no' ){
							$community = $host['snmp']['community'];

							if(isset($host['snmp']['details']['sysObjectID']) && isset($host['snmp']['details']['sysDescr'])){
								$objectid = preg_replace('#OID:\s+#','',$host['snmp']['details']['sysObjectID']);
								$sysdescr = explode(':',$host['snmp']['details']['sysDescr'],2)[1];

								include_once $path.'/libs/logo_oid.hash.php';
								$logo = IANA::getManufacturerLogo(array($objectid), $sysdescr);
								if( $logo['logo'] != 'none') $logo_type['img'] = $logo['logo'];
								if( $logo['name'] != 'none') $logo_type['text'] = $logo['name'];
								else if( $logo['oid'] != 'none') $logo_type['text'] = 'Object ID : ' . $logo['oid'];

								$is_gesa = !empty($db_data['scan_agent_id']);

								$settings = IANA::getSettingsName(array($objectid), $sysdescr);
								$pattern  = IANA::getPatternAdvised($is_gesa,$settings);
								$dev_type = IANA::getNodeType($settings);
								if( $pattern == null ) $pattern = ICMP_ONLY;
								if( $dev_type == null ) $dev_type = 'switch';
							}
						}
						else $community = '';

						$mac=$host['mac'];
						$mac_vendor=Model_esia::searchMacVendor($dbconnection,$mac);
						if( $mac_vendor == null ) $mac_vendor="";

						$same_address = 0;
						if(array_key_exists($host['address'],$already_encoded_list['address'])){
							$same_address = $already_encoded_list['address'][$host['address']];
						}

						if(array_key_exists($name,$already_encoded_list['name'])){
							$name = array('value' => $name,'mode'=>'invalid');
						}

						if( $parsed['type'] == 'MAC-ICMP' ){
							$dev_type = 'phone';
							$pattern = PHONE_ONLY;
						}

						$data_array[] = array(
								'logo_type' => $logo_type,
								'http_url'	=> $http_url,
								'snmp_status' => $lang['IMPORT_HOSTS_PORT_STATUS'][$snmp_status],
								'address' 	=> $host['address'],
								'same_addr'	=> $same_address,
								'mac'		=> array("mac" => $mac, "vendor" => $mac_vendor),
								'hostname'	=> $host['hostname'],
								'name'		=> $name,
								'group'		=> '',
								'snmp_ver'	=> $snmp,
								'community' => $community,
								'type'		=> $dev_type,
								'rdp'		=> 'none',
								'pattern'	=> $pattern
						);
					}
				}
			}


			$smarty->assign('gesa_sn',$db_data['scan_agent_id']);
			if(isset($header_array)) $smarty->assign('header_array',$header_array);
			if(isset($data_array)) $smarty->assign('data_array',$data_array);

			if(!$user->isFinishingTutoriel(5)) {
				$smarty->assign('seeTutos',5);
			}

			$smarty->assign("error_messages",$error_messages);
			unset($_REQUEST);
			$agent = $_SERVER['HTTP_USER_AGENT'];
			if(preg_match('/Linux/',$agent)) $smarty->assign("os",'Linux');
			$smarty->display("$template_path/import-listhost.html");
	}
}
else
{

    $smarty->display('no_access.html');
    exit(0);
}

function getNodeParam($name,$default=null){
	if(empty($_REQUEST['name']))	return $default;
	else return $_REQUEST['name'];
}


function send_status($status,$message){
	switch($status){
		case 'success' :
			$ui_state='ui-state-active';
			$icon='ui-icon-circle-check';
			break;
		case 'warning' :
			$ui_state = 'ui-state-highlight';
			$icon = 'ui-icon-info';
			break;
		case 'alert' :
			$ui_state = 'ui-state-error';
			$icon = 'ui-icon-alert';
	}
	echo "<p><div class='$ui_state ui-corner-all'>
	<span class='ui-icon $icon' style='float: left; margin-right:.3em;'></span>$message
	</div></p>";
}

//Les groupes non trouvés sont ignorés. On peut vérifier en comparant la taille de $groupArrayPath avec celle de l'array retourné
function getGroupIdArrayByArrayPath($dbconnection,$groupArrayPath){
	$modelGroups = Model_esia::getGroupDeviceIn($dbconnection, null);

	if(is_string($groupArrayPath)) $groupArrayPath = explode(",",$groupArrayPath);

	$groupIdArray = array();
	foreach($groupArrayPath as $groupPath){  //Pour chacun des group
		if(empty(trim($groupPath))) break;
		$pathElements=explode("->",$groupPath);
		$childsCurrentGroup = $modelGroups;

		foreach($pathElements as $pathElement){  //On parcours le path
			$currentGroup = null;
			foreach($childsCurrentGroup as $child) {             //On cherche le group en cours
				if(trim($child["name"]) == trim($pathElement)){
					$currentGroup = $child;
					break;
				}
			}
			$childsCurrentGroup = $currentGroup["child"];
		}
		if( $currentGroup != null ) array_push($groupIdArray,$currentGroup["id"]);
	}

	return $groupIdArray;
}

function getAllGroups($dbconnection,$header='',$groups=null){
	$array_groups=array();

	if( $groups == null ) {
		$groups = Model_esia::getGroupDeviceIn($dbconnection, null);
	}

	foreach($groups as $group_fields){
		array_push($array_groups,$header.$group_fields['name']);
		//$array_groups[$group_fields['id']] = $header.$group_fields['name'];
		if(!empty($group_fields['child']))
			$array_groups = array_merge($array_groups,getAllGroups($dbconnection,$header.$group_fields['name'].'->',$group_fields['child']));
	}
	sort($array_groups,SORT_STRING|SORT_FLAG_CASE);
	return $array_groups;
}

function getAllTypes($dbconnection){
	$array_types=array();

	$devices_types = Model_esia::getDeviceType($dbconnection, null, null);
	foreach($devices_types as $type){
		array_push($array_types,$type["name"]);
	}

	sort($array_types,SORT_STRING|SORT_FLAG_CASE);
	return $array_types;
}

function getAllPatterns($dbconnection){
	$array_patterns=array();

	$patterns=Model_adm::getPatternService($dbconnection);
	foreach($patterns as $pattern){
		array_push($array_patterns,$pattern["name"]);
	}

	sort($array_patterns,SORT_STRING|SORT_FLAG_CASE);
	return $array_patterns;
}

function getAlreadyEncodedNodes($dbconnection,$gesa_id=null){
	$devices=Model_esia::getNodeList($dbconnection);
	$devices_list['address']	= array();
	$devcieS_list['name']		= array();
	foreach($devices as $device){
		$device_gesa = Model_esia::getGesaLink($dbconnection,$device['id']);
		if( $device_gesa != null ) $device_gesa = $device_gesa->getId();
		if( $device_gesa == $gesa_id) {
			if( empty($devices_list['address'][$device['ip']] ))
				$devices_list['address'][$device['ip']] = 1;
				else $devices_list['address'][$device['ip']]++;
		}

		$devices_list['name'][$device['name']]=true;
	}
	return $devices_list;
}
?>
