<?php
//inclusion des fichiers principaux
$path = $_SERVER['DOCUMENT_ROOT'];
include_once $path.'/common.php';
include_once $path.'/Model_esia.php';
include_once $path.'/plugin/gesa/gesa_model.php';
include_once DEVICE_CLASS;


$wp_db = Model_esia::getWebPlugin($dbconnection,false,'WEBP_IMPORT');
$plugin_url = $wp_db[0]['apache_path'];
$template_path= $path.$plugin_url.'template/';
include_once $path.$plugin_url.'/inc/Model_import-module.php';

//Récupération des infos de scans
$scan_id = $_REQUEST['taskid'];
$scan = Model_ScanModule::getScanningTask($dbconnection,$scan_id);

$scan_json = json_decode(file_get_contents($scan['data_path']),true);

//Selection de(s) la communauté(s) a tester.
if(empty($_REQUEST['com'])){
	if( $scan['type'] == 'SNMP' ){
		$communities = $scan['options'];
	}
	else $communities = 'public';
}
else $communities = $_REQUEST['com'];


//Creation du device
$device = new Device();
$device->setIPv4Adress($_REQUEST['ip']);

//Derrière unity
$is_gesa = false;
if( isset($scan['scan_agent_id']) ){
	$is_gesa = true;
	include_once GESA_CLASS;
	$gesa = new GESA();
    $gesa->SetSerialNumber($scan['scan_agent_id']);

    //$ip=Model_gesa::getIpGesa($dbconnection,intval($scan['scan_agent_id']));
    //$gesa->setPublicIPaddress(long2ip($ip));
    $device = new RemoteDevice($device,$gesa);
}

//Paramètres par defaut
$json["found"] = false;
$json["snmp_ver"] = "none";
$json["snmp_com"] = "";
$json["node_logo"] = "none";
$json["node_type"] = "none";
$json["node_pattern"] = null;
$json["check_snmp"] = "closed";

//Detection SNMP
$device->setSNMPVersion(2);
//Detection SNMP
foreach(explode(',',$communities) as $community){
	try{
		$version = $device->detectSNMPVersion($community);

		if( $version == null ) continue;
		
		$device->setSNMPVersion($version);
		$device->setSNMPCommunity($community);

		$objectId= $device->getSysObjectId();
		$sysDescr = $device->getSysDescr();

		//SNMP détecté
		include_once $path.'/libs/logo_oid.hash.php';
		$logo = IANA::getManufacturerLogo($objectId, $sysDescr);
		$settings = IANA::getSettingsName($objectId, $sysDescr);
		$pattern  = IANA::getPatternAdvised($is_gesa,$settings);
		$dev_type = IANA::getNodeType($settings);

		if( $logo['logo'] != 'none') $logo_type['img'] = $logo['logo'];
		if( $logo['name'] != 'none') $logo_type['text'] = $logo['name'];
		else if( $logo['oid'] != 'none') $logo_type['text'] = 'Object ID : ' . $logo['oid'];

		if( $dev_type == null ) $dev_type = 'switch';

		$json["found"] = true;
		if( $version == 1 ) $json["snmp_ver"] = "v1";
		else if( $version == 2 ) $json["snmp_ver"] = "v2c";

		foreach($scan_json['hosts'] as $k=>$host)
		{
			if($host['address']== $device->getIPv4Adress())
			{
				foreach($host['ports'] as $kp => $port)
				{
					if($port['portid']=='161')
					{
						$scan_json['hosts'][$k]['ports'][$kp]['status']='open';
						break;
					}
				}
				
				$scan_json['hosts'][$k]['snmp']['status'] = 'yes';
				$scan_json['hosts'][$k]['snmp']['version'] = $version;
				$scan_json['hosts'][$k]['snmp']['community'] = $community;
				$scan_json['hosts'][$k]['snmp']['details']['sysDescr'] = "STRING: \"".$sysDescr."\"";
				$scan_json['hosts'][$k]['snmp']['details']['sysObjectID'] = "OID: ".$objectId[0];
			}
		}
		
		file_put_contents($scan['data_path'],json_encode($scan_json));
		$json["snmp_com"] = $community;
		$json["node_logo"] = $logo_type['img'];
		$json["node_desc"] = $logo_type['text'];
		$json["node_type"] = $dev_type;
		$json["node_pattern"] = $pattern;
		$json["check_snmp"] = "open";
		break;
	}
	catch(Exception $ex){
		//On ignore l'exception
	}
}

echo json_encode($json,JSON_PRETTY_PRINT);
?>