<?php
//inclusion des fichiers principaux
$path = $_SERVER['DOCUMENT_ROOT'];
include_once $path.'/common.php';
include_once $path.'/plugin/gesa/gesa_model.php';


if(isset($_GET["success"]) && $_REQUEST['action'] != "delete"){

	$smarty->assign("success_message",sprintf($lang['IMPORT_SCAN_SAVED_TASK_MESSAGE'],$_GET["id"]));
	
	unset($_GET);
	unset($_POST);
	unset($_REQUEST);
}

$arr = Model_esia::getWebPlugin($dbconnection,false,'WEBP_IMPORT');
$plugin_url = $arr[0]['apache_path'];

$page_url = "$plugin_url/".$arr[0]['index_page'];
$template_path= $path.$plugin_url.'template/';

include_once $path.$plugin_url.'/inc/Model_import-module.php';

$smarty->assign('title',$lang[$arr[0]['name']]);
$smarty->assign('page_url',$page_url);

//NAVBAR
$navbar->addElement($lang[$arr[0]['name']],$page_url,$arr[0]['icon']);

//Récupération des agents disponibles
if($licence['type'] =='Galaxy' || $licence['type'] =='Infinity'|| strpos($licence['type'],'Mercury')!==FALSE ||  strpos($licence['type'],'Mecosi')!==FALSE)
{
	$addr = $_SERVER['SERVER_ADDR'];
	$mask = '255.255.255.0';
	
	$int_addr = ip2long($addr);
	$int_mask = ip2long($mask);
	$int_net = $int_addr & $int_mask;
	$int_bc = $int_addr | (~ $int_mask);
	
	if( $int_net == 0 || $int_bc >= 3758096384){
		$scan_agents["server"] = array(
				array("ID"=>"this","name"=>"127.0.0.1","desc"=>"This")
		);
	}
	else{
		$int_first = $int_net+1;
		$int_last = $int_bc-1;
		
		$first_addr = long2ip($int_first);
		$last_addr = long2ip($int_last);
		
		$scan_agents["server"] = array(
				array("ID"=>"this","name"=>"127.0.0.1","desc"=>"This",'first_addr'=>$first_addr,'last_addr'=>$last_addr)
		);
	}
}
$scan_agents["gesa"] = array();

$list = Model_esia::getNodeList($dbconnection,null,null,Model_esia::NODE_INSTANCE);
foreach($list as $device){
	if($device->getType() == 'gesa' ){
		$gesa=Model_gesa::getInstanceGESA($dbconnection,$device->getID());
		
		$gesa->constructDevice($device);
		
		$sn = $gesa->getSerialNumber();
		$desc = $gesa->getName();
		
		$addr = $gesa->getLocalIPaddress();
		$mask = '255.255.255.0';
		
		$int_addr = ip2long($addr);
		$int_mask = ip2long($mask);
		$int_net = $int_addr & $int_mask;
		$int_bc = $int_addr | (~ $int_mask);	
		//Si l'integer vaut 0, alors elle n'est pas définie, 3758096384 => 224.0.0.0
		if( $int_net == 0 || $int_bc >= 3758096384){
			array_push($scan_agents["gesa"],array('ID'=>$sn,'name'=>$sn,'desc'=>$desc));
		}
		else{
			$int_first = $int_net+1;
			$int_last = $int_bc-1;
		
			$first_addr = long2ip($int_first);
			$last_addr = long2ip($int_last);
		
			array_push($scan_agents["gesa"],array('ID'=>$sn,'name'=>$sn,'desc'=>$desc,'first_addr'=>$first_addr,'last_addr'=>$last_addr));
		}
	}
}

class AgentsList{
	private $by_id;
	private $by_name;
	private $by_desc;
	
	public function __construct($agents_array){
		foreach($agents_array as $agent_type){
			foreach($agent_type as $agent){
				$this->by_id[$agent["ID"]] = $agent;
				$this->by_name[$agent["name"]] = $agent;
				$this->by_desc[$agent["desc"]] = $agent;
			}
		}
	}
	
	public function getById($key){
		if(isset($this->by_id[$key])) return $this->by_id[$key];
		return null;
	}
	
	public function getByName($key){
		if(isset($this->by_name[$key])) return $this->by_name[$key];
		return null;
	}
	
	public function getByDesc($key){
		if(isset($this->by_desc[$key])) return $this->by_desc[$key];
		return null;
	}
}

if($user->getDroits($dbconnection,"esia_import") == 1 && $user->getDroits($dbconnection,"esia_administration") == 1)
{		
	
	$agents_search = new AgentsList($scan_agents);
	
	$snmp_communities="public,esia_read";
	
	$error_messages=array();
	
	$smarty->assign('scan_agents',$scan_agents);
	
	if(count($_REQUEST)>0){
		if(isset($_REQUEST['action']) && $_REQUEST['action'] == 'delete'){
			$smarty->assign("exclude_canvg_js",true);
			$smarty->assign('message_only',true);
			$scan = $_REQUEST['scan_id'];
			try{
				Model_ScanModule::deleteScanningTask($dbconnection,$scan);
				$smarty->assign('success_message',sprintf($lang['IMPORT_SCAN_DELETED_MESSAGE'],$scan));
			}
			catch (Exception $ex){
				$error_messages[]=sprintf($lang['IMPORT_SCAN_UNABLE_TO_DELETE_ERROR'],$scan_id,$ex->getMessage());
			}
		}
		else 
		{
			//Validation
			if(!valid_select("select_scan_agent",$agents_search))	
				$error_messages[]=$lang['IMPORT_SCAN_INVALID_AGENT_ERROR'];
			if(!valid_IP_range("start_addr","end_addr",256))	
				$error_messages[]=$lang['IMPORT_SCAN_INVALID_RANGEIP_ERROR'];
			if(!valid_communities("select_snmp_communities")) 
				$error_messages[]=$lang['IMPORT_SCAN_INVALID_COMMUNITIES_ERROR'];
			if(count($error_messages) == 0 )
			{					
				try
				{
					$agent_id = null;
					if(isset($_REQUEST['select_scan_agent'])) $agent_id = $_REQUEST['select_scan_agent'];
					if( $agent_id == 'this' ) $agent_id = null;
					if($_REQUEST['scan_type'] == 'SNMP'){
						$task_id = Model_ScanModule::startScanningTask($dbconnection,$_REQUEST['start_addr'],$_REQUEST['end_addr'],$agent_id,$_REQUEST['scan_type'],$_REQUEST['select_snmp_communities']);
					}
					else{
						$task_id = Model_ScanModule::startScanningTask($dbconnection,$_REQUEST['start_addr'],$_REQUEST['end_addr'],$agent_id,$_REQUEST['scan_type'],null);
					}
					header("Location:".$page_url."?success=1&id=".$task_id);
				}catch(Exception $ex){
					$error_messages[]=sprintf($lang['IMPORT_SCAN_UNABLE_TO_SAVE_ERROR'],$ex->getMessage());
				}
			}
		}
	}	
	
	$select_scan_agent = "this";
	$start_addr = $end_addr = "";
	$select_snmp_communities = 'public,read';
	
	if(isset($_REQUEST["scan_type"]))				$scan_type  		= $_REQUEST["scan_type"];
	if(isset($_REQUEST["select_scan_agent"]))		$select_scan_agent  = $_REQUEST["select_scan_agent"];
	if(isset($_REQUEST["start_addr"]))				$start_addr			= $_REQUEST["start_addr"];
	if(isset($_REQUEST["end_addr"]))				$end_addr			= $_REQUEST["end_addr"];
	if(isset($_REQUEST["select_snmp_communities"]))	$select_snmp_communities = $_REQUEST["select_snmp_communities"];
	
	$smarty->assign('select_scan_agent',$select_scan_agent);
	$smarty->assign('start_addr',$start_addr);
	$smarty->assign('end_addr',$end_addr);
	$smarty->assign('select_snmp_communities',$select_snmp_communities);
	
	try{
		$task_list = Model_ScanModule::getScanningTaskList($dbconnection,true);
	}catch(Exception $ex){
		$error_messages[]='Unable to get scan task list : '.$ex->getMessage();
	}
	
	$actual_time=time();
	$scan_array=array();
	$errors_array=array();
	foreach($task_list as $task){
		//TODO : Supprimer la lecture dans le fichier sur cette page ?
		if( $task['actual_status'] == Model_ScanModule::TERMINATED_TASK ){ //Alors on récupére les données supplémentaires
			$file = $task['data_path'];
			$raw = file_get_contents($file);
			$parsed = json_decode($raw,true);
			
			if(!isset($parsed["status"])){
				$error_messages[] = sprintf($lang['IMPORT_ALL_PARSING_FILE_ERROR'],$task['id'],$file); 
			}
			else{
				$devices_up = $parsed['metadata']['host_up'];
				$devices_down = $parsed['metadata']['host_down'];
				$since_status = explode('.',$parsed['metadata']['started_date'])[0];
				$action_see="$plugin_url"."host-list.php?task_id=".$task['id'];
			}
		}
		else{
			$devices_down = '';
			$devices_up = '';
			$action_see = '';
		}
		
		if(isset($lang['IMPORT_SCAN_TASK_STATUS'][$task['actual_status']])){
			$status = $lang['IMPORT_SCAN_TASK_STATUS'][$task['actual_status']];
		} 
		else{
			$status = $task['actual_status'];
		}

		$device_agent = $task['scan_agent_id'];
		if($device_agent == null)  $device_agent = '127.0.0.1 (This)';
		else $device_agent = $agents_search->getById($task['scan_agent_id'])['desc']." (".$task['scan_agent_id'].")"; //Affichage nom (SN) pour la source
		
		if( $task['actual_status'] == Model_ScanModule::ERROR_TASK ){	
			$errors_array[] = array(
					"scan_id"			=> $task['id'],
					"scan_type"			=> $task['type'],
					"scan_options"		=> $task['options'],
					"scan_device" 		=> $device_agent,
					"scan_actual_status"=> $status,
					"status_last_change"=> preg_replace('(.\d+)$','',$task['changed_time']),
					"start_addr"		=> $task['start_addr'],
					"end_addr" 			=> $task['end_addr'],
					"error_message"		=> $task['error_message'],
					'actions'		  	=> '',
			);
		}
		else{	
			$scan_array[] = array(
					"scan_id"			=> $task['id'],
					"scan_type"			=> $task['type'],
					"scan_options"		=> $task['options'],
					"scan_device" 		=> $device_agent,
					"scan_actual_status"=> $status,
					"status_last_change"=> preg_replace('/(.\d+)$/','',$task['changed_time']),
				//	"status_last_change"=> formatSeconds($actual_time-$since_status).' ('.@date(DateTime::RFC1036,$since_status).')', => 7d 23:21:31 (Wed, 16 Nov 16 11:10:05 +0100)
					"start_addr"		=> $task['start_addr'],
					"end_addr" 			=> $task['end_addr'],
					//"total_addr"		=> count(explode(',',$parsed["addresses"])),
					"free_addr"			=> $devices_down,
					"detected_devices" 	=> $devices_up,
					'actions'		  	=> $action_see,
			);
		}
	}

	if(!$user->isFinishingTutoriel(4)) {
		$smarty->assign('seeTutos',4);
	}
	
	$smarty->assign("scan_status",$scan_array);
	$smarty->assign("scan_errors",$errors_array);
	$smarty->assign("error_messages",$error_messages);
	
	//$smarty->display("$template_path/import-scanlist.html");
	$smarty->display("$template_path/import-scanlist.html");
}
else
{
        $smarty->assign('no_header',true);
        $smarty->display('no_access.html');
        exit(0);
}

	
function formatSeconds($time){
	$days = intval($time/86400);
	$time = $time%86400;
	
	$hours = intval($time/3600);
	$time = $time%3600;
	
	$min = intval($time/60);
	$sec = $time%60;
	
	$days = str_pad($days,4," ",STR_PAD_LEFT);
	$hours = str_pad($hours,2,"0",STR_PAD_LEFT);
	$min = str_pad($min,2,"0",STR_PAD_LEFT);
	$sec = str_pad($sec,2,"0",STR_PAD_LEFT);
	
	return $days."d $hours:$min:$sec";
}

function associative_to_smarty_array($arr){
	$cols = array_keys($arr[0]);
	$data=array();
	
	foreach($arr as $line){
		foreach($line as $cell){
			array_push($data,$cell);
		}
	}
	return array("cols"=>implode(',',$cols),"data"=>$data);
}

function valid_select($param_name,$agents_search){
	if(empty($_REQUEST[$param_name])) return false;
	return ($agents_search->getById($_REQUEST[$param_name])!=null);
}

function valid_IP_range($param1,$param2,$max_addr){
	if(empty($_REQUEST[$param1])) return false;
	if(empty($_REQUEST[$param2])) return false;
	
	$first_int=ip2long($_REQUEST[$param1]);
	$last_int=ip2long($_REQUEST[$param2]);
	
	if(!$first_int || !$last_int || $first_int>$last_int )	return false;
	if($max_addr < ($last_int - $first_int))				return false;
	return true;
}

function valid_communities($param_name){
	if(empty($_REQUEST[$param_name])) return false;
	$communities=explode(",",$_REQUEST[$param_name]); 
	
	if(count($communities) < 1 ) return false;
	
	while(count($communities)>0){
		$community = array_shift($communities);
		if(strpos(trim($community),' ')) return false; //Pas d'espaces au milieu de la com
		if(in_array($community,$communities)) return false; //Pas de doublons
	}	
	return true;
}
?>
